#include <future.h>

// Helper functions which use the methods.

template<class F>
uint8_t use_future( F& f );

template<class F>
uint8_t use_future( F& f )
{  
  if( !f.is_ready() )
  {
    f.wait();
  }
  
  return f.get();
}

template<class P>
void use_promise( P& p );

template<class P>
void use_promise( P& p )
{  
  if( p.accepts_value() )
  {
    p.set_value(10);
  }
}


void setup() {
}

void loop() {

  // Use a volatile temporary to prevent the compiler from optimizing the call away.
  volatile uint8_t tmp = 0;
  
  // Create a future without virtual inheritance.
  future_s<uint8_t> f;

  // Call the functions which use the methods.
  use_promise(f);
  tmp = use_future(f);

}