#include <future.h>

// Helper functions which use the methods.

template<class T>
uint8_t use_future( future<T>& f );

template<class T>
uint8_t use_future( future<T>& f )
{  
  if( !f.is_ready() )
  {
    f.wait();
  }
  
  return f.get();
}

template<class T>
void use_promise( promise<T>& p );

template<class T>
void use_promise( promise<T>& p )
{  
  if( p.accepts_value() )
  {
    p.set_value(10);
  }
}


void setup() {
}

void loop() {

  // Use a volatile temporary to prevent the compiler from optimizing the call away.
  volatile uint8_t tmp = 0;
  
  // Create a future with virtual inheritance.
  future_v<uint8_t> f;
  
  // Call the functions which use the base class.
  use_promise(f);
  tmp = use_future(f);
  
  // Create references with the type of the base class.
  future<uint8_t> &fr = f;
  promise<uint8_t> &pr = f;

  // Call the functions using the specific references.
  use_promise(pr);
  tmp = use_future(fr);

}